Fire Net HDU

Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall. 

A blockhouse is a small castle that has four openings through which to shoot. The four openings are facing North, East, South, and West, respectively. There will be one machine gun shooting through each opening. 

Here we assume that a bullet is so powerful that it can run across any distance and destroy a blockhouse on its way. On the other hand, a wall is so strongly built that can stop the bullets. 

The goal is to place as many blockhouses in a city as possible so that no two can destroy each other. A configuration of blockhouses is legal provided that no two blockhouses are on the same horizontal row or vertical column in a map unless there is at least one wall separating them. In this problem we will consider small square cities (at most 4x4) that contain walls through which bullets cannot run through. 

The following image shows five pictures of the same board. The first picture is the empty board, the second and third pictures show legal configurations, and the fourth and fifth pictures show illegal configurations. For this board, the maximum number of blockhouses in a legal configuration is 5; the second picture shows one way to do it, but there are several other ways. 



Your task is to write a program that, given a description of a map, calculates the maximum number of blockhouses that can be placed in the city in a legal configuration. 

Input

The input file contains one or more map descriptions, followed by a line containing the number 0 that signals the end of the file. Each map description begins with a line containing a positive integer n that is the size of the city; n will be at most 4. The next n lines each describe one row of the map, with a '.' indicating an open space and an uppercase 'X' indicating a wall. There are no spaces in the input file.

Output

For each test case, output one line containing the maximum number of blockhouses that can be placed in the city in a legal configuration. 

Sample Input

4
.X..
....
XX..
....
2
XX
.X
3
.X.
X.X
.X.
3
...
.XX
.XX
4
....
....
....
....
0

Sample Output

5
1
5
2
4

对于本题第一眼想的就是类似八皇后的做法 但发现不可行

转而考虑复杂度更高的搜索算法

因为数据范围很小 所以直接 暴力出2^16种情况

然后check就完事了

#include<cstdio>
#include<iostream>
#include<string>
#include<queue>
#include<cmath>
#include<algorithm>
#include<cstring>
#include<set>
using namespace std;

int n;
char mp[10][10];
int ans;

void check()
{
    int tmp=0;
    int flag=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(mp[i][j]=='1')
            {
                tmp++;
                int tmp1=i,tmp2=j;
                tmp1--;
                while(tmp1>0)
                {
                    if(mp[tmp1][tmp2]=='1') flag=1;
                    if(mp[tmp1][tmp2]=='X') break;
                    tmp1--;
                }
                tmp1=i,tmp2=j;
                tmp1++;
                while(tmp1<=n)
                {
                    if(mp[tmp1][tmp2]=='1') flag=1;
                    if(mp[tmp1][tmp2]=='X') break;
                    tmp1++;
                }
                tmp1=i,tmp2=j;
                tmp2++;
                while(tmp2<=n)
                {
                    if(mp[tmp1][tmp2]=='1') flag=1;
                    if(mp[tmp1][tmp2]=='X') break;
                    tmp2++;
                }
                tmp1=i,tmp2=j;
                tmp2--;
                while(tmp2>0)
                {
                    if(mp[tmp1][tmp2]=='1') flag=1;
                    if(mp[tmp1][tmp2]=='X') break;
                    tmp2--;
                }
            }
            if(flag==1) break;
        }
        if(flag==1) break;
    }
    if(flag==0)
    {
        ans=max(ans,tmp);
    }
    return ;
}

void dfs(int x,int y)
{
    int tmp1,tmp2;
    if(y==1&&x==n+1)
    {
        check();
        return ;
    }
    else if(y==n) tmp1=x+1,tmp2=1;
    else  tmp1=x,tmp2=y+1;
    if(mp[x][y]=='X')
    {
        dfs(tmp1,tmp2);
    }
    else
    {
        mp[x][y]='1';
        dfs(tmp1,tmp2);
        mp[x][y]='0';
        dfs(tmp1,tmp2);
    }
    return;
}

int main()
{
    while(cin>>n)
    {
        if(n==0) break;
        ans=0;
        for(int i=1;i<=n;i++)
            scanf("%s",mp[i]+1);
        dfs(1,1);
        printf("%d
",ans);
    }
}

看了题解发现这题居然可以二分图匹配来写

二分图写法见下一篇blog

原文地址:https://www.cnblogs.com/caowenbo/p/11852267.html